/* uevt-udisks-interfaces.vala for UEvt
 *
 * Copyright (c) 2010 by Albar Boris <elentir@frugalware.org>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

namespace UDisks {

    [DBus (name = "org.freedesktop.UDisks")]
    interface Daemon: Object
    {
        public abstract ObjectPath[] enumerate_devices() throws IOError;

        public signal void device_added(ObjectPath device);
        public signal void device_removed(ObjectPath device);
        public signal void device_changed(ObjectPath device);

        public abstract string daemon_version { owned get; }
    }

    [DBus (name = "org.freedesktop.UDisks.Device")]
    interface Device: Object
    {
        public abstract async string filesystem_mount(string filesystem_type, string[] options) throws IOError;
        public abstract async void filesystem_unmount(string[] options) throws IOError;

        public abstract string device_file { owned get; }
        public abstract string id_usage { owned get; }
        public abstract string id_type { owned get; }
        public abstract string id_version { owned get; }
        public abstract string id_uuid { owned get; }
        public abstract string id_label { owned get; }
        public abstract bool device_is_mounted { owned get; }
        public abstract bool device_is_partition { owned get; }
        public abstract bool device_is_removable { owned get; }
        public abstract bool device_is_system_internal { owned get; }
        public abstract bool device_is_drive { owned get; }
        public abstract bool device_is_read_only { owned get; }
        public abstract bool device_is_media_available { owned get; }
        public abstract bool device_is_optical_disc { owned get; }
        public abstract bool optical_disc_is_closed { owned get; }
        public abstract uint optical_disc_num_tracks { owned get; }
        public abstract uint optical_disc_num_audio_tracks { owned get; }
        public abstract uint optical_disc_num_sessions { owned get; }
        public abstract bool optical_disc_is_blank { owned get; }
        public abstract bool optical_disc_is_appendable { owned get; }
        public abstract bool device_presentation_hide { owned get; }
        public abstract bool device_presentation_nopolicy { owned get; }
        public abstract string[] device_mount_paths { owned get; }
    }
}
