/* uevt-notify.vala for UEvt
 *
 * Copyright (c) 2010 by Albar Boris <elentir@frugalware.org>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

using GLib;
using Notify;

namespace UEvt
{
    void init_notification()
    {
        if(Notify.is_initted())
            return;

        Notify.init("uevt");
    }

    void uninit_notification()
    {
        Notify.uninit();
    }

    void run_notification(string head, string body, string icon, string plugin)
    {
        bool notify = false;

        if(coldplug == true)
            return;

        /* check if we have to notify the user */
        try {
            notify = config.get_boolean(config.UEVT_GROUP_NOTIFY, plugin);
        } catch (KeyFileError kf) {
            warning("Error when reading UEvt configuration : %s", kf.message);
        }

        if(notify != true)
            return;

        Notification notif = new Notification(head, Markup.escape_text(body), icon);

        try {
            notif.show();
        } catch (Error e) {
            warning("Notification Error: %s", e.message);
        }
    }
}