/* utils.vala for UEvt
 *
 * Copyright (c) 2010 by Albar Boris <elentir@frugalware.org>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

using GLib;

namespace UEvt
{

    void run_command_config(string group, string function, string param1, string param2, bool sync)
    {
        string cmd;

        if(coldplug == true)
            return;

        try {
            cmd = config.get_string(group,function);
        } catch (KeyFileError kf) {
            warning("Error when reading UEvt configuration : %s\nIgnoring command",
                    kf.message);
            return;
        }

        run_command(cmd, param1, param2, sync);
    }

    int run_command(string cmd, string param1, string param2, bool sync)
    {
        if(cmd == "")
            return 0;
        string firstvar = cmd.replace("$1", param1);
        string formatted_cmd = firstvar.replace("$2", param2);
        string[] cmd_cut = formatted_cmd.split(";", 0);

        try {
            foreach(string scmd in cmd_cut) {
                if(scmd != "") {
                    if(sync == false) {
                        if(Process.spawn_command_line_async(scmd))
                            message("Execute command : %s", scmd);
                    } else {
                        if(Process.spawn_command_line_sync(scmd))
                            message("Execute command : %s", scmd);
                    }
                }
            }
        } catch(SpawnError s) {
            message(s.message);
            return 1;
        }

        return 0;
    }
}